const {OD,OASGN,sign_str,add_repr,is_bigint,is_ary} = require("nv-facutil-basic");

const _jfmt_dict = (d) => {
    let nd = {}
    for(let k in d) {
        let v = d[k];
        if(is_bigint(v)) {
            nd[k] = String(v);
        } else {
            nd[k] = v
        }
    }
    return(nd)
}
const jfmt_rslt = (o)=> {
    if(is_ary(o)) {
        return(o.map(d=>_jfmt_dict(d)))
    } else if(o instanceof Object){
        return(_jfmt_dict(o))
    } else {
        return(o)
    }
}

const jfmt_maybe_ary_rslt  = (reply)=> {
    let [cond,...rslt]  = reply;
    if(rslt.length===1)   {rslt=rslt[0]} else {}
    rslt                = jfmt_rslt(rslt);
    if(is_ary(rslt))      {rslt = rslt[0]} else {}
    return([cond,rslt])
}

module.exports = {
    _jfmt_dict,
    jfmt_rslt,
    jfmt_maybe_ary_rslt,
}
